#ifndef SHARED_DEFS
#define SHARED_DEFS

#define CMD_NOTHING                 0
#define CMD_SET_DATA                1
#define CMD_SET_HIGHLIGHTED_DATA    2
#define CMD_SET_RECTANGLE           3
#define CMD_SET_POLYGON             4
#define CMD_SET_POLYLINE            5

#define MAX_POINTS 350

class Point2D {
  public:
    float x,y;
};

// Auxiliary class to receive multi-purpose data from Prolog. For example,
// Prolog might want to set the whole set of points for display with one
// command, and set just a subset for highlighting with another. Or Prolog
// might want to close this program n'shit like that... You get the idea.
// We won't actually make any instance of this object, instead, we will set-up
// the shared memory object and store the instance there. Thus, Prolog and
// C will use the same amount of memory.
class PrologData {
  public:
    int Command, nPoints;
    Point2D Points[MAX_POINTS];
};

#define SHAREDMEM_NAME "RoboVisBuffer"

#endif
