#ifndef SHARED_MEM_H
#define SHARED_MEM_H

/*
  Synchronized shared memory for basic interprocess communication
*/

#include <windows.h>

class SharedMem {
  private: 
    HANDLE hMapFile, hRWMutex;
    int SharedMemSize;
    bool MemAvailable;
    
  public:
    char SharedMemName[20];
    LPVOID MemPtr;
    
    SharedMem(char *Name, int Size);
    ~SharedMem();
    int GetSize();
    char *GetName();
    void *GetMemory();
    void Write(void *Src, int Bytes);
    void Read(void *Dest, int Bytes);
};

#endif
